//IEFU29   JOB (SMP),'INSTALL IEFU29',                                  00010000
//             CLASS=A,MSGCLASS=A,MSGLEVEL=(1,1),REGION=4096K           00020000
//********************************************************************* 00030000
//*                                                                     00040000
//*                       MVS 3.8 SYSGEN                                00050000
//*                       ==============                                00060000
//*                                                                     00070000
//* DESC: INSTALL USERMOD JLM0001 TO AUTOMATICALLY START SMFDUMP        00080000
//*       PROCEDURE WHEN SMF DATASET BECOMES FILLED.                    00090000
//*                                                                     00100000
//********************************************************************* 00110000
//*                                                                     00120000
/*MESSAGE  *******************************************                  00130000
/*MESSAGE  *                                         *                  00140000
/*MESSAGE  * THIS USERMOD BECOMES EFFECTIVE ONLY     *                  00150000
/*MESSAGE  * IF YOU DO AN IPL WITH THE CLPA OPTION   *                  00160000
/*MESSAGE  *                                         *                  00170000
/*MESSAGE  *******************************************                  00180000
//CLEANUP EXEC PGM=IDCAMS                                               00190000
//SYSPRINT DD  SYSOUT=*                                                 00200000
//SYSIN    DD  *                                                        00210000
 DELETE SYS1.UMODSRC(IEFU29) NONVSAM                                    00220000
 SET MAXCC = 0                                                          00230000
 SET LASTCC = 0                                                         00240000
//ADD     EXEC PGM=IEBUPDTE,PARM=NEW                                    00250000
//SYSPRINT DD  SYSOUT=*                                                 00260000
//SYSUT2   DD  DISP=SHR,DSN=SYS1.UMODSRC                                00270000
//SYSIN    DD  DATA,DLM=$$                                              00280000
./ ADD NAME=IEFU29                                                      00290000
IEFU29   TITLE 'SMF SWITCH EXIT ROUTINE                        '        00300000
*---------------------------------------------------------------------* 00310000
*                                                                     * 00320000
*             MODULE NAME = IEFU29                                    * 00330000
*                                                                     * 00340000
*                SMF EXIT ROUTINE TO START DUMP OF SMF WHEN SMF       * 00350000
*                DATASET NEEDS TO BE DUMPED.                          * 00360000
*                                                                     * 00370000
*                                                                     * 00380000
*             FUNCTION =                                              * 00390000
*                ISSUES START COMMAND FOR SYS1.PROCLIB(SMFDUMP)       * 00400000
*                PROCEDURE.                                           * 00410000
*                                                                     * 00420000
*                OPERATION =                                          * 00430000
*                   ISSUES COMMAND 'START SMFDUMP,DSN=SMFDSN'         * 00440000
*                   WHERE SMFDSN WILL BE REPLACED BY THE NAME OF      * 00450000
*                   THE SMF DATASET TO BE DUMPED (SYS1.MANX OR        * 00460000
*                   SYS1.MANY) AND WILL ISSUE A WTO THAT THE          * 00470000
*                   START COMMAND HAS BEEN ISSUED.                    * 00480000
*                                                                     * 00490000
*                 REGISTER CONVENTIONS = STANDARD CONVENTIONS.        * 00500000
*                    REGISTERS 0 TO 1  = WORK REGISTERS               * 00510000
*                    REGISTERS 2 TO 11 = UNUSED                       * 00520000
*                    REGISTER  12      = ADDRESSABILITY TO IEFU29     * 00530000
*                                        CSECT                        * 00540000
*                    REGISTER  13      = ADDRESSIBILITY TO DATA DSECT * 00550000
*                    REGISTERS 14,15   = WORK REGISTERS               * 00560000
*                                                                     * 00570000
*             INPUT = REG1 POINTS TO FULLWORD ADDRESS OF DATA SET     * 00580000
*                     NAME (SYS1.MANX/SYS1.MANY) TO BE DUMPED.        * 00590000
*                                                                     * 00600000
*             OUTPUT = NONE                                           * 00610000
*                                                                     * 00620000
*             RETURN CODE = 0004 TO PREVENT SMF FROM ISSUING          * 00630000
*             MESSAGE IEE362A OR IEE362I                              * 00640000
*                                                                     * 00650000
*             MACROS = SAVE, WTO, RETURN, GETMAIN, FREEMAIN           * 00660000
*                                                                     * 00670000
*---------------------------------------------------------------------* 00680000
         EJECT                                                          00690000
IEFU29   CSECT ,                                                        00700000
*                                                                       00710000
@IDENT01 B     @IDENT04(R15)       BRANCH AROUND IDENT CONSTANTS        00720000
         DC    AL1(@IDENT03-@IDENT02)                                   00730000
@IDENT02 DC    C'IEFU29 '                                               00740000
         DC    C'&SYSDATE &SYSTIME - '                                  00750000
         DC    C'SMF DATASET SWITCH USER EXIT'                          00760000
@IDENT03 DS    0H                                                       00770000
@IDENT04 EQU   *-@IDENT01                                               00780000
*                                                                       00790000
         SAVE  (14,12)             SAVE REGISTERS                       00800000
         USING IEFU29,R12          SET UP BASE ADDRESSABILITY           00810000
         USING DATA,R13            SET UP DATA AREA ADDRESSABILITY      00820000
         LR    R12,R15             LOAD BASE REG WITH ENTRY POINT       00830000
         L     R8,0(R1)            SAVE INPUT PARM(DSNAME)              00840000
         GETMAIN R,LV=LENDATA      GET STORAGE                          00850000
         ST    R13,4(R1)           SAVE CALLER'S SAVE AREA ADDR         00860000
         ST    R1,8(R13)           SAVE MY SAVE AREA ADDRESS            00870000
         LR    R13,R1              LOAD SAVE AREA ADDRESS               00880000
*                                                                       00890000
*---------------------------------------------------------------------* 00900000
* CHECK FOR JES RUNNING ... IF NOT, EXIT WITH NO FURTHER ACTION       * 00910000
*---------------------------------------------------------------------* 00920000
         L     R5,16               ADDRESS CVT                    JLM   00930000
         L     R5,296(R5)          ADDRESS JEST                   JLM   00940000
         L     R5,24(R5)           ADDRESS SSCT                   JLM   00950000
         L     R5,16(R5)           ADDRESS SSCT+10                JLM   00960000
         LTR   R5,R5               IS JES AVAILABLE?              JLM   00970000
         BZ    EXITNOW               NO, EXIT WITHOUT DUMP        JLM   00980000
*---------------------------------------------------------08/2004 JLM-* 00990000
*                                                                       01000000
         MVC   ENQLIST(LENQLIST),ENQLSTX LOAD IN MODEL PARM LIST        01010000
         ENQ   MF=(E,ENQLIST)      TEST IF RESOURCE IN USE?             01020000
         LTR   R15,R15             WAS THE RESOURCE AVAILABLE?          01030000
         BNZ   EXITNOW             NO, EXIT W/O STARTING DUMP           01040000
*                                                                       01050000
         MVC   WTOAREA(WTOLEN),WTOL    MOVE IN WTO MESSAGE              01060000
         MVC   WTOAREA+DSNOFF(1),8(R8)  MOVE DSN ID TO MSG              01070000
         MVC   CMDAREA(CMDLEN),CMDL    MOVE IN START COMMAND            01080000
         MVC   CMDAREA+DSNCOFF(1),8(R8)  MOVE DSN ID TO START CMD       01090000
         SLR   R0,R0               CLEAR REG ZERO FOR SVC 34            01100000
         LA    R1,CMDAREA          POINT TO START COMMAND               01110000
         SVC   34                  ISSUE START COMMAND                  01120000
         WTO   MF=(E,WTOAREA)      ISSUE MESSAGE TO OPERATOR            01130000
*                                                                       01140000
EXITNOW  LR    R1,R13              LOAD ADDRESS OF GETMAINED AREA       01150000
         L     R13,4(R13)          RESTORE CALLER'S SAVE AREA           01160000
         FREEMAIN R,LV=LENDATA,A=(R1)  FREE ACQUIRED STORAGE            01170000
         LM    14,12,12(13)        RESTORE CALLER'S REGISTERS           01180000
         LA    15,4                SET RETURN CODE TO 4                 01190000
         BR    R14                 RETURN                               01200000
*                                                                       01210000
         EJECT                                                          01220000
*---------------------------------------------------------------------* 01230000
*                      CONSTANT DATA AND EQUATES                      * 01240000
*---------------------------------------------------------------------* 01250000
SMFQNAME DC    CL8'SMFQUEUE'                                            01260000
SMFRNAME DC    CL7'DATASET'                                             01270000
*                                                                       01280000
CMDL     DS    0F                  START COMMAND FORMAT FOR SVC 34      01290000
         DC    AL2(CMDLEN),AL2(00) LENGTH OF STRING                     01300000
         DC    C'START SMFDUMP,ID=X'  COMMAND                           01310000
*                456789012345678901                                     01320000
CMDLEN   EQU   *-CMDL              LENGTH OF COMMAND                    01330000
DSNCOFF  EQU   21                  OFFSET OF DSN FIELD IN COMMAND       01340000
*                                                                       01350000
WTOL     WTO   'IEFU29 HAS ISSUED COMMAND ''START SMFDUMP,ID=X ''',    C01360000
               ROUTCDE=(1,2,11),MF=L                                    01370000
*               456789012345678901234567890 123456789012345678          01380000
WTOLEN   EQU   *-WTOL              LENGTH OF WTO STRING                 01390000
DSNOFF   EQU   48                  OFFSET OF DSN FIELD IN MESSAGE       01400000
ENQLSTX  ENQ   (SMFQNAME,SMFRNAME,E,,SYSTEM),RET=TEST,MF=L              01410000
*                                                                       01420000
R0       EQU   0                                                        01430000
R1       EQU   1                                                        01440000
R2       EQU   2                                                        01450000
R3       EQU   3                                                        01460000
R4       EQU   4                                                        01470000
R5       EQU   5                                                        01480000
R6       EQU   6                                                        01490000
R7       EQU   7                                                        01500000
R8       EQU   8                                                        01510000
R9       EQU   9                                                        01520000
R10      EQU   10                                                       01530000
R11      EQU   11                                                       01540000
R12      EQU   12                                                       01550000
R13      EQU   13                                                       01560000
R14      EQU   14                                                       01570000
R15      EQU   15                                                       01580000
         EJECT                                                          01590000
*---------------------------------------------------------------------* 01600000
*                   DATA DSECT (ACQUIRED BY GETMAIN)                  * 01610000
*---------------------------------------------------------------------* 01620000
DATA     DSECT                                                          01630000
SAVE     DS    18F                REGISTER SAVE AREA                    01640000
CMDAREA  DS    0F,XL(CMDLEN)      AREA FOR COMMAND                      01650000
WTOAREA  DS    0F,XL(WTOLEN)      AREA FOR WTO PARM LIST                01660000
ENQLIST  ENQ   (SMFQNAME,SMFRNAME,E,,SYSTEM),RET=TEST,MF=L              01670000
LENQLIST EQU   *-ENQLIST          LENGTH OF WTO STRING                  01680000
RESERVED DS    4D                 RESERVED                              01690000
LENDATA  EQU   *-DATA             EQUATE FOR LENGTH OF DATA DSECT       01700000
*                                                                       01710000
         END   IEFU29                                                   01720000
$$                                                                      01730000
//ASM    EXEC SMPASM,M=IEFU29,COND=(0,NE)                               01740000
//RECAPP EXEC SMPAPP,COND=(0,NE)                                        01750000
//SMPPTFIN DD  *                                                        01760000
++USERMOD (JLM0001).                                                    01770000
++VER (Z038) FMID(EBB1102).                                             01780000
++MOD(IEFU29) TXLIB(UMODOBJ).                                           01790000
//SMPCNTL  DD  *                                                        01800000
 REJECT  SELECT(JLM0001).                                               01810000
 RESETRC.                                                               01820000
 RECEIVE SELECT(JLM0001).                                               01830000
 APPLY   SELECT(JLM0001)                                                01840000
         DIS(WRITE)                                                     01850000
         .                                                              01860000
//                                                                      01870000
